using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

namespace Pentium4emulator
{
    public partial class MyTableViewer : UserControl
    {
        public MyTableViewer() {
            InitializeComponent();
            //dataGridView1.Columns.Add("icon", "");
            //dataGridView1.Columns.Add("type", "Type");
            //dataGridView1.Columns.Add("message", "Message");
            //dataGridView1.Columns[0].Width = 18;
            //dataGridView1.Columns[1].Width = 100;
			dataGridView1.Columns[3].Width =
				this.Size.Width -
				dataGridView1.Columns[0].Width -
				dataGridView1.Columns[1].Width -
				dataGridView1.Columns[2].Width;
            //dataGridView1.Rows.Add(new object[] { this.imageList1.Images[2], "Message", "This program was written by Sushovan De" });
            //dataGridView1.Rows.Add(new object[] { this.imageList1.Images[1], "Message", "Please say 'hi' to him at sushovande@gmail.com" });
        }

        private void onMyPaint(object sender, PaintEventArgs e) {
            dataGridView1.Columns[3].Width = this.Size.Width -
                dataGridView1.Columns[0].Width -
				dataGridView1.Columns[1].Width -
				dataGridView1.Columns[2].Width -
                5;
        }

        public void clear() {
            dataGridView1.Rows.Clear();
        }

        public void addMessage(int lineNumber, string message) {
            dataGridView1.Rows.Add(new object[]{
                this.imageList1.Images[0],
				lineNumber,
                "Message",
                message}
            );
        }
		public void addError(int lineNumber, string message) {
            dataGridView1.Rows.Add(new object[]{
                this.imageList1.Images[2],
				lineNumber,
                "Error",
                message}
            );
        }
		public void addWarning(int lineNumber, string message) {
            dataGridView1.Rows.Add(new object[]{
                this.imageList1.Images[1],
				lineNumber,
                "Message",
                message}
            );
        }

		public delegate void myEventHandler();
		public delegate void showLocation(int line);

		public event myEventHandler minimiseRequested;
		public event showLocation cellDoubleClicked;

		private void button1_Click(object sender, EventArgs e) {
			minimiseRequested();
		}

		private void MyControlGotFocus(object sender, EventArgs e) {
			this.panel1.BackColor = Color.FromArgb(0,127,255);
//			this.panel1.BackColor = SystemColors.ActiveCaption;
			this.label1.ForeColor = SystemColors.ActiveCaptionText;
		}

		private void MyControlLostFocus(object sender, EventArgs e) {
			this.panel1.BackColor = System.Drawing.SystemColors.InactiveBorder;
			this.label1.ForeColor = Color.Black;
		}

		private void MyCellDoubleClicked(object sender, DataGridViewCellEventArgs e) {
			int row = e.RowIndex;
			int line = (int)this.dataGridView1.Rows[row].Cells[1].Value;
			cellDoubleClicked(line);
		}


        //private void onSelChange(object sender, EventArgs e) {
        //    int i = dataGridView1.SelectedCells[0].RowIndex;
        //    dataGridView1.Rows[i].Selected = true;
        //}
    }
}
