        public void executeOpcode(string s) {
            if(s.StartsWith("movl")) {
                s= s.Substring(4);
                s = s.Trim();
                int temp = getValueFrom(ref s, true);
                saveValueTo(s, temp);
            }
            else if(s.StartsWith("addl")){
                resetflags();
                s = s.Substring(4);
                s = s.Trim();
                int temp = getValueFrom(ref s,true);
                int temp2 = getValueFrom(ref s, false);
                int sum = temp2+temp;
                saveValueTo(s,sum);
                //check for overflow
                if((temp < 0 && temp2 < 0 && sum > 0)
                    || (temp > 0 && temp2 > 0 && sum < 0)) {
                    flag[flags.overflow] = true;
                    flag[flags.carry] = true;
                }
                //check for zero
                if(sum == 0) flag[flags.zero] = true;
                //check for sign
                if(sum < 0) flag[flags.sign] = true;
                //future: check for auxiliary carry - whatever that means
            }
            else if(s.StartsWith("subl")) {
                resetflags();
                s = s.Substring(4);
                s = s.Trim();
                int temp = getValueFrom(ref s, true);
                int temp2 = getValueFrom(ref s, false);
                int difference = temp2 - temp;
                saveValueTo(s, difference);                //check for overflow
                if((temp > 0 && temp2 < 0 && difference > 0)
                    || (temp < 0 && temp2 > 0 && difference < 0)) {
                    flag[flags.overflow] = true;
                    flag[flags.carry] = true;
                }
                //check for zero
                if(difference == 0) flag[flags.zero] = true;
                //check for sign
                if(difference < 0) flag[flags.sign] = true;
                //future: check for auxiliary carry - whatever that means

            }
            else if(s.StartsWith("imul")) {
                resetflags();
                s = s.Substring(4);
                s = s.Trim();
                long temp = getReg(regtype.eax);
                long temp2 = getValueFrom(ref s, false);
                long product = temp * temp2;
                int lowerbits = (int)(product & -1);
                int higherbits = (int)(product>>32);
                registers[regtype.eax] = lowerbits;
                registers[regtype.edx] = higherbits;
                //Carry and overfloaw flags are set if overflowed the lower bits
                if(product>0xffffffffL || product<-0xffffffffL){
                    flag[flags.overflow] = true;
                    flag[flags.carry] = true;
                }
                //Sf, af, etc are undefined - see manual page 497
            }
            else if(s.StartsWith("andl")){
                resetflags();
                s = s.Substring(4);
                s = s.Trim();
                int temp = getValueFrom(ref s,true);
                int temp2 = getValueFrom(ref s, false);
                int result = temp&temp2;
                saveValueTo(s, result);
                //of and cf are cleared.
                flag[flags.overflow] = false;
                flag[flags.auxiliarycarry] = false;
                //sign flag
                if(result < 0) flag[flags.sign] = true;
                //zero flag
                if(result == 0) flag[flags.zero] = true;
                bool pf = false;
                int j=1;
                for(int i = 0; i < 32; i++) {
                    if((result & j) != 0) pf = !pf;
                    j = j << 1;
                }
                if(pf) flag[flags.parity] = true;
            }//todo: the rest of the flag settings
            else if(s.StartsWith("orl")) {
                s = s.Substring(3);
                s = s.Trim();
                int temp = getValueFrom(ref s, true);
                int temp2 = getValueFrom(ref s, false);
                saveValueTo(s, temp | temp2);
            }
            else if(s.StartsWith("xorl")) {
                s = s.Substring(4);
                s = s.Trim();
                int temp = getValueFrom(ref s, true);
                int temp2 = getValueFrom(ref s, false);
                saveValueTo(s, temp ^ temp2);
            }
            else if(s.StartsWith("negl")) {
                s = s.Substring(4);
                s = s.Trim();
                int temp = getValueFrom(ref s, false);
                saveValueTo(s, -temp);
            }
            else if(s.StartsWith("incl")) {
                s = s.Substring(4);
                s = s.Trim();
                int temp = getValueFrom(ref s, false);
                saveValueTo(s, temp+1);
            }
            else if(s.StartsWith("decl")) {
                s = s.Substring(4);
                s = s.Trim();
                int temp = getValueFrom(ref s, false);
                saveValueTo(s, temp-1);
            }
            else if(s.StartsWith("shll")) {
                resetflags();
                s = s.Substring(4);
                s = s.Trim();
                int temp = getValueFrom(ref s, true);
                int temp2 = getValueFrom(ref s, false);
                int sum = temp2<<temp;
                saveValueTo(s, sum);
                
                //Todo: The carry flag must be set.

                //check for zero
                if(sum == 0) flag[flags.zero] = true;
                //check for sign
                if(sum < 0) flag[flags.sign] = true;
            }
            else if(s.StartsWith("sall")) {
                resetflags();
                s = s.Substring(4);
                s = s.Trim();
                int temp = getValueFrom(ref s, true);
                int temp2 = getValueFrom(ref s, false);
                int sum = temp2 << temp;
                saveValueTo(s, sum);

                //Todo: The carry flag must be set.

                //check for zero
                if(sum == 0) flag[flags.zero] = true;
                //check for sign
                if(sum < 0) flag[flags.sign] = true;
            }
            else if(s.StartsWith("shrl")) {
                resetflags();
                s = s.Substring(4);
                s = s.Trim();
                int temp = getValueFrom(ref s, true);
                int temp2 = getValueFrom(ref s, false);
                int sum = 0;
                if(temp > 0) {
                    if(temp2 < 0) {
                        temp2 = temp2 >> 1;
                        temp2 = temp2 & 0x7fffffff;
                        sum = temp2 >> (temp - 1);
                    }
                    else sum = temp2 >> temp;
                }
                saveValueTo(s, sum);

                //Todo: The carry flag must be set.

                //check for zero
                if(sum == 0) flag[flags.zero] = true;
                //check for sign
                if(sum < 0) flag[flags.sign] = true;
            }
            else if(s.StartsWith("sarl")) {
                resetflags();
                s = s.Substring(4);
                s = s.Trim();
                int temp = getValueFrom(ref s, true);
                int temp2 = getValueFrom(ref s, false);
                int sum = temp2 >> temp;
                saveValueTo(s, sum);

                //Todo: The carry flag must be set.

                //check for zero
                if(sum == 0) flag[flags.zero] = true;
                //check for sign
                if(sum < 0) flag[flags.sign] = true;
            }
            else if(s.StartsWith("cmpl")) {
                resetflags();
                s = s.Substring(4);
                s = s.Trim();
                int temp = getValueFrom(ref s, true);
                int temp2 = getValueFrom(ref s, false);
                if(temp == temp2) flag[flags.zero] = true;
                if(temp > temp2) flag[flags.carry] = true;
            }
            else if(s.StartsWith("pushl")) {
                s = s.Substring(5);
                s = s.Trim();
                int temp = getValueFrom(ref s, false);
                registers[regtype.esp] -= 4;
                parent.mr.saveValue(registers[regtype.esp], temp);
            }
            else if(s.StartsWith("popl")) {
                s = s.Substring(4);
                s = s.Trim();
                int temp = parent.mr.getIntValue(registers[regtype.esp]);
                registers[regtype.esp] += 4;
                saveValueTo(s, temp);
            }
            else if(s.StartsWith("call")) {
                s = s.Substring(4).Trim();
                //push the return address
                registers[regtype.esp] -= 4;
                parent.mr.saveValue(registers[regtype.esp], codesegment+ registers[regtype.epc]);
                //and jump to the label
                int targetline = parent.labels[s];//catch the error here
                registers[regtype.epc] = targetline - 1;//epc will be incremented at the end of this function
            }
            else if(s.StartsWith("ret")) {
                //pop the return address
                int temp = parent.mr.getIntValue(registers[regtype.esp]);
                registers[regtype.esp] += 4;
                if(temp < codesegment) parent.handleerror("return address on stack not valid");
                registers[regtype.epc] = temp - codesegment;
            }
            else if(s.StartsWith("jmp")) {
                s = s.Substring(3);
                s = s.Trim();
                int targetline = parent.labels[s];//catch the error here
                registers[regtype.epc] = targetline - 1;//epc will be incremented at the end of this function
            }
            else if(s.StartsWith("jge")) {
                s = s.Substring(3).Trim();
                if(!flag[flags.carry]) {
                    int targetline = parent.labels[s];//catch the error here
                    registers[regtype.epc] = targetline - 1;//epc will be incremented at the end of this function
                }
            }
            //This should be AFTER all the other opcodes that START WITH jg
            else if(s.StartsWith("jg")) {
                s = s.Substring(2).Trim();
                if(!flag[flags.carry] && !flag[flags.zero]) {
                    int targetline = parent.labels[s];//catch the error here
                    registers[regtype.epc] = targetline - 1;//epc will be incremented at the end of this function
                }
            }
            else if(s.StartsWith("je")) {
                s = s.Substring(2).Trim();
                if(flag[flags.zero]) {
                    int targetline = parent.labels[s];//catch the error here
                    registers[regtype.epc] = targetline - 1;//epc will be incremented at the end of this function
                }
            }
            else if(s.StartsWith("jle")) {
                s = s.Substring(3).Trim();
                if(flag[flags.carry]||flag[flags.zero]) {
                    int targetline = parent.labels[s];//catch the error here
                    registers[regtype.epc] = targetline - 1;//epc will be incremented at the end of this function
                }
            }
            else if(s.StartsWith("jl")) {
                s = s.Substring(2).Trim();
                if(flag[flags.carry] && !flag[flags.zero]) {
                    int targetline = parent.labels[s];//catch the error here
                    registers[regtype.epc] = targetline - 1;//epc will be incremented at the end of this function
                }
            }
            else if(s.StartsWith("jne")) {
                s = s.Substring(3).Trim();
                if(!flag[flags.zero]) {
                    int targetline = parent.labels[s];//catch the error here
                    registers[regtype.epc] = targetline - 1;//epc will be incremented at the end of this function
                }
            }
            else if(s.StartsWith("jz")) {
                s = s.Substring(2).Trim();
                if(flag[flags.zero]) {
                    int targetline = parent.labels[s];//catch the error here
                    registers[regtype.epc] = targetline - 1;//epc will be incremented at the end of this function
                }
            }
            else if(s.StartsWith("jnz")) {
                s = s.Substring(3).Trim();
                if(!flag[flags.zero]) {
                    int targetline = parent.labels[s];//catch the error here
                    registers[regtype.epc] = targetline - 1;//epc will be incremented at the end of this function
                }
            }
            registers[regtype.epc]++;
        }